require 'syslibgem/version'
require 'syslibgem/server'
require 'syslibgem'
require 'thor'
require 'colorize'
require 'bundler'

module Syslibgem
  # The user cli usin thor
  class CLI < Thor
    desc 'show', 'show required system libraries'
    def show
      gems = Bundler.load.specs.map(&:name)
      respose = Server.load(gems)
      libraries = respose['data']['dependencies']
      unknown = respose['data']['unknown']
      os_name = Server.find_os
      system_libraries_install(os_name, libraries)
      ask_to_learn(unknown)
    end
    desc 'system_libraries_install', 'handel instalation'
    def system_libraries_install(os_name, libraries)
      puts 'Your system needs to install these libraries
      to be able to run bundle install'.yellow
      puts libraries.join(', ').red
      if os_name == 'lunix'
        install_lunix(libraries)
      elsif os_name == 'mac'
        install_mac(libraries)
      else
        abort 'sorry your os is not supported'.red
      end
    end
    desc 'install_lunix', 'install list of system libraries'
    def install_lunix(libraries)
      libraries.each do |pkg|
        puts "Do you want to install #{pkg} library? (y/n)".blue
        system("sudo apt-get -y install #{pkg}") if input
      end
    end
    desc 'install_mac', 'install list of system libraries'
    def install_mac(libraries)
      libraries.each do |pkg|
        puts "Do you want to install #{pkg} library? (y/n)".blue
        system("bower install #{pkg} --no-interactive") if input
      end
    end
    desc 'ask_to_learn', 'asks the user to teach the gem'
    def ask_to_learn(gems)
      puts 'I don\'t know about these gems would
       you like to help me? (y/n)'.yellow
      puts gems.join(', ').red
      learn(gems) if input
    end
    desc 'learn', 'let the user to introduce gems dependencies'
    def learn(gems)
      gems.each do |gem|
        puts "Do you want teach me #{gem} libraries? (y/n)".blue
        push_new_gem(gem) if input
      end
    end
    desc 'push_new_gem', 'teachs the servers a new gem'
    def push_new_gem(gem)
      puts 'add the dependencies names sperated by comma'.blue
      STDOUT.flush
      line = STDIN.gets.chomp
      deps = line.delete(' ').split(',')
      Server.create(gem, deps) unless deps.empty?
    end
    desc 'input', 'reads user input'
    def input
      STDOUT.flush
      input = STDIN.gets.chomp
      if 'yY'.include? input
        true
      else
        false
      end
    end
  end
end
