require 'httparty'
require 'json'
require 'os'

# This class handel the server requests
class Server
  include HTTParty

  $URI = 'https://desolate-refuge-66236.herokuapp.com'
  # $URI = 'http://localhost:3000'

  def self.create(gem, deps)
    json = { gem_name: gem, os_name: find_os, deps: deps }
    HTTParty.post(
      $URI + '/api/v1/deps',
      body: json.to_json,
      headers:  { 'Content-Type' => 'application/json',
                  'Accept' => 'application/json' }
    )
  end

  def self.load(gems)
    json = { gems: gems, os_name: find_os }
    HTTParty.get($URI + '/api/v1/deps', query: json)
  end

  def self.find_os
    if OS.mac?
      'mac'
    elsif OS.linux?
      'lunix'
    else
      'unknown'
    end
  end
end
